Tee ohjelma Tuotteet, joka kysyy tuotteen tiedot (numero, nimi, hinta ja kuvaus). Nimestä poistetaan tyhjät merkit alusta sekä lopusta, ja nimi muunnetaan suurella kirjoitetuksi. Kuvauksesta poistetaan tyhjät merkit alusta ja lopusta.

Jos kuvaus on tyhjä merkkijono, kuvausriviä ei tulosteta lainkaan.

Huom! Kun luette käyttäjältä numeroita ja tekstiä vuoron perään nextInt-, nextDouble- ja nextLine-metodeilla, jää "tietovirtaan" rivinvaihtomerkkejä. Tätä ongelmaa käsitellään Stack Overflow -keskustelussa: https://stackoverflow.com/a/13102066 

```
Example output:
Anna tuotenumero: 1234
Anna tuotteen nimi:     Porsche
Anna tuotteen hinta:   423000,00
Anna tuotteen kuvaus:  Punainen

Numero: 1234
Nimi: PORSCHE
Hinta: 423000,00
Kuvaus: Punainen
```

--------------------

**Tuotteet.java**

```
import java.util.Scanner;
import java.text.DecimalFormat;

public class Tuotteet {
    public static void main(String[] args) {

        Scanner syote = new Scanner(System.in);
        DecimalFormat r2 = new DecimalFormat(".00");

        int tuotenumero;
        String nimi, kuvaus;
        double hinta;

        System.out.print("Anna tuotenumero: ");
        tuotenumero = syote.nextInt();
        System.out.print("Anna tuotteen nimi: ");
        nimi        = syote.next();
        System.out.print("Anna tuotteen hinta: ");
        hinta       = syote.nextDouble();
        System.out.print("Anna tuotteen kuvaus: ");
        kuvaus      = syote.next();

        // Remove leading & trailing spaces, convert to uppercase
        nimi = nimi.trim().toUpperCase();

        kuvaus = kuvaus.trim();

        System.out.printf(
                "Numero: %s\nNimi: %s\nHinta: %s\n",
                tuotenumero, nimi, r2.format(hinta)
        );
        if (!kuvaus.isEmpty()) {
            System.out.printf("Kuvaus: %s\n", kuvaus);
        }
    }
}
```
